/* kentta.cpp */
/****************************************************************************/
/*
**        K E N T T A . C P P
**
** Abstrakti luokka yleiselle tietueen kentlle: cKentta
** sek cKentasta perittyj luokkia
**
**
**  Tekijt:          Vesa Lappalainen
**                    Ohjelmointikurssi 1996
**  Tehty:            07.01.1996
**  Kommentit ja pivityshistoria ks. kentta.h
**
*/

#include <ctype.h>
#include <iostream>
#include <string>
using namespace std;
#include "kentta.h"
#include "muunnos.h"
#include "pvm.h"


//============================================================================
// Kenttien metodeja:
//============================================================================

//============================================================================
// Yleisi apualiohjelmia:
//============================================================================

cKenttavirhe hetu_tarkistus(string &jono,const char *sa,int yks)
{
  string s(sa);
  const char *sc = s.c_str();

  jono_isoksi(s); poista_tyhjat(s);
  jono = s;

   // Tyhj sotu hyvksytn!
  if ( s == "" ) {
    return KENTTA_OK;
  }

  // Jo pivmr vrin, hyltn.
  if ( tarkista_sotu_pvm(sc) ) {
    return cKenttavirhe(KENTTA_MUUTETTU_KYSY,"Hetussa pivmr vrin!");
  }

  // Pelkk syntymaika hyvksytn!
  if ( s.length() == 6  ) {
    return yks ? KENTTA_OK_VAROITA_MUUT : KENTTA_OK;
  }

  // En kelpaa muoto ppkkvv+/-nnnT
  if ( s.length() != 11 ) {
    return cKenttavirhe(KENTTA_MUUTETTU_KYSY,
                        "Hetussa pit olla 11 merkki!");
  }

  if ( !strchr(HETUVALI,s[6]) ) {      // Pit olla + tai -
    return cKenttavirhe(KENTTA_MUUTETTU_KYSY,"Hetussa pit syntymajan ja "
              "tunnuksen vlill olla jokin merkeist:" HETUVALI );
  }

  // Loppu ei numeerinen
  if ( !( isdigit(s[7]) && isdigit(s[8]) && isdigit(s[9]) ) ) {
    return cKenttavirhe(KENTTA_MUUTETTU_KYSY,
      "Tunnusosan kaikki merkit eivt ole numeroita");
  }


  // En tarkistusmerkin oikeellisuus jljell!
  long int alku,loppu;
  sscanf(sc,"%6ld",&alku);
  sscanf(sc+7,"%3ld",&loppu);

  char tm = HETUTARK[(int)((alku*1000+loppu) % 31)];

  if ( s[10] != tm ) {
    s[10] = tm;
    jono = s;
    return cKenttavirhe(KENTTA_MUUTETTU_KYSY,"Tarkistusmerkki muutettu!");
  }

  return yks ? KENTTA_OK_ONKO_AINOA : KENTTA_OK;
}

