/* kerho.h */
/*
**  Tekijt:          Vesa Lappalainen
**                    Ohjelmointikurssi 1991-
** Kommentit ks. kerho.cpp
*/

#ifndef __KERHO_H
#define __KERHO_H

#include <string>
using std::string;
#include "jasenet.h"


//----------------------------------------------------------------------------
// Kerhon mrittely
//----------------------------------------------------------------------------
class cKerho {
  cJasenet jasenet;

  void alusta()                          {                                   }
public:
  cKerho() : jasenet()                   { alusta();                         }
  ~cKerho()                              { talleta();                        }

  string lue_tiedostosta(const string &tied);
  string talleta(const string &tied);
  string talleta()                       { return talleta("");               }

  const string &Kerhon_nimi()    const   { return jasenet.Koko_nimi();       }
  int Jasenia()                  const   { return jasenet.Lkm();             }
  // poista poistaa jsenistst ja harrasteista ne joilla on nro. Tekemtt!
  int poista(int nro)                    { return 0;                         }
  int Muutettu()                 const   { return jasenet.Muutettu();        }
  int TeeBak(const string &bak_tark)     { return jasenet.TeeBak(bak_tark);  }
  string luo(const string &tied,const string &nimi,int max_koko)
                                   { return jasenet.luo(tied,nimi,max_koko); }
  string Tiedoston_nimi() const    { return jasenet.Tiedoston_nimi();        }  
  string Bak_nimi() const          { return jasenet.Bak_nimi();              }
  string lisaa(const cJasen &jasen){ return jasenet.lisaa(jasen);            }
  const cJasen &anna_jasen(int i)  { return jasenet.anna(i);                 }
  int   laske_montako_muuta(const cJasen &jasen, int k,int &kuka) const
    { return jasenet.laske_montako_muuta(jasen,k,kuka); }
  string korvaa(int i,const cJasen &jasen) { return jasenet.korvaa(i,jasen); }
  void etsi(cPermutaatio &loytyneet,int k,const string &jono) {
    jasenet.etsi(loytyneet,k,jono);
  }
  void poista_ind(int ind)         { jasenet.poista_ind(ind);                }
};


#endif
