/* naytto.h */
/*
** Kerho-ohjelman nyttluokka
**
** Tekijt:          Vesa Lappalainen
**                   Ohjelmointikurssit 1991-2000
** Liskommentit ks. naytto.cpp
*/


#ifndef __NAYTTO_H
#define __NAYTTO_H

#include <iostream>
//using std::ostream;
#include "kerho.h"
#include "help.h"


//----------------------------------------------------------------------------
// Vakiota
//----------------------------------------------------------------------------

typedef enum {
  TOIM_JATKA,
  TOIM_SEURAAVA,
  TOIM_EDELLINEN,
  TOIM_KYSY_UUDELLEEN,
  TOIM_LOPUT_OLETUS,
  TOIM_LOPETA
} eToiminto;



//----------------------------------------------------------------------------
//  Nytn mrittely:
//----------------------------------------------------------------------------

class cNaytto {
  cKerho *kerho; // Osoitin kerhoon => voi olla sama kerho monessa nytss
  cHelp help;
  int nykyjasen;
  string ohjelman_nimi; // Esim. help-toimintoa varten
  void tulosta(std::ostream &os,const cJasen &jasen);
  int  kysy_tiedot(cJasen &jasen);
  void korjaile_jasenta(int ind);
  bool poista(int ind);

  void logo(void);
  void avustus(char valinta);
  void paamenu();
  void lisaa_uusi_jasen(char valinta);
  void etsi_jasenen_tiedot(char valinta);
  void selaa_ja_korjaa(bool korjaile);
  void tulosteet(char valinta);
  void tietojen_korjailu(char valinta);
  void paivita_jasenmaksuja(char valinta);
  eToiminto kysy_tavallinen_kentta(cJasen &jasen, int k);
  eToiminto kysy_listakentta(cJasen &apujasen,int k);
  void alusta(cKerho *p,const string &ohj_nimi);
public:
  cNaytto(cKerho *p)                  { alusta(p,""); }
  cNaytto(cKerho *p,const string &on) { alusta(p,on); }
  ~cNaytto();

  void ohjeet(void);
  void kiitokset(void);

  int  lue_tiedosto(const string &tied_nimi);
  int  lue_tiedosto() { return lue_tiedosto(""); }
  int  talleta();
  int  kysy_talleta();

  int  paavalinta();
};


#endif
